#--
# Copyright (c) 2010 Moodstocks SAS
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# or in the LICENSE file which you should have received as part of
# this distribution.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#++

module MNotes class Object
  
  class << self
    
    def find(fpath, user=nil)
      user ||= User::last
      q = user.query(fpath)
      q.note.delete
      q.found ? q.object : nil
    end
    
    def retrieve(id, user=nil)
      new(id, user)
    end
    
  end # class << self
  
  attr_reader :id, :votes, :notes
  
  def initialize(h, user=nil)
    refresh(h, user)
  end
  
  def refresh(h=nil, user=nil)
    h ||= @id
    if h.is_a?(String)
      user ||= User::last
      refresh( Map[user.jbody(:get, "object/#{h}")] )
    else
      raise "Object#refresh called with a #{h.class}" unless h.is_a?(Hash)
      h = Map(h)
      @id, @votes = h.values_at(:id, :votes)
      @notes = h[:notes].map_mr(:new, Note)
      self
    end
  end
  
end end
